/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.stimmeingabe.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class StimmeingabefehlerExtendedDAO extends AbstractStimmeingabefehlerDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: ErgebniseingangAndFehlerartBeschreibungNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT s.beschreibung FROM Stimmeingabefehler s WHERE s.stimmeingabe.ergebniseingang = ?1 AND s.fehlerart = ?2<br>
* SQL: <br>
*/
@Override
public java.util.List<java.lang.String> findByErgebniseingangAndFehlerartBeschreibung( @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang ergebniseingang,  @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehlerart fehlerart) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmeingabefehler.findByErgebniseingangAndFehlerartBeschreibung" ,  ergebniseingang ,  fehlerart  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByErgebniseingangAndFehlerartBeschreibung(): Miss");
        }

        cache.put(key, super.findByErgebniseingangAndFehlerartBeschreibung( ergebniseingang ,  fehlerart  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByErgebniseingangAndFehlerartBeschreibung(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<java.lang.String>) cache.lookup(key));
    }

    return super.findByErgebniseingangAndFehlerartBeschreibung( ergebniseingang ,  fehlerart  );
}
/**
* Name: ErgebniseingangBeschreibungNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT s.beschreibung FROM Stimmeingabefehler s WHERE s.stimmeingabe.ergebniseingang = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<java.lang.String> findByErgebniseingangBeschreibung( @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang ergebniseingang) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmeingabefehler.findByErgebniseingangBeschreibung" ,  ergebniseingang  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByErgebniseingangBeschreibung(): Miss");
        }

        cache.put(key, super.findByErgebniseingangBeschreibung( ergebniseingang  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByErgebniseingangBeschreibung(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<java.lang.String>) cache.lookup(key));
    }

    return super.findByErgebniseingangBeschreibung( ergebniseingang  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
